/* This is a copy of the specs for Kings Castle by Sapowax  modified to gizmo 
   format.  Please use this style in general.  Note: Bassman will update this 
   format soon so check for the most recent version.
*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>

#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"
#include "limits.h"
#include "cmd.h"

extern struct room_data *world;
extern struct index_data *mob_index;
extern struct index_data *obj_index;
extern struct time_info_data time_info;

int guild(CHAR *ch, int cmd, char *arg);
CHAR *get_random_victim(CHAR *ch);
void stop_fighting(CHAR *ch);
void set_fighting(CHAR *ch, CHAR *tar_ch);
void hit(CHAR *ch, CHAR *tar_ch, int type);
void cast_colour_spray(byte level,CHAR *ch,char *arg,int type,CHAR *tar_ch,OBJ *tar_obj);
void cast_heal(byte level, CHAR *ch, char *arg, int type, CHAR *tar_ch, OBJ *tar_obj);
void cast_harm(byte level, CHAR *ch, char *arg, int type, CHAR *tar_ch, OBJ *tar_obj);
void cast_fireball(byte level, CHAR *ch, char *arg, int type,CHAR *tar_ch, OBJ *tar_obj);
void do_follow(CHAR *ch, char *argument, int cmd);

/* this creates a self_assiging zone file */

void assign_welmar(void)
{
	int member_of_staff (CHAR *ch);
	int member_of_royal_guard (CHAR *ch);
	CHAR *find_npc_by_name (CHAR *chAtChar, char *pszName, int iLen);
	CHAR *find_guard (CHAR *chAtChar);
	CHAR *get_victim (CHAR *chAtChar);
	int banzaii (CHAR *ch);
	int do_npc_rescue (CHAR *hero, CHAR *victim);
	int block_way(CHAR *ch, int cmd, char *arg, int iIn_room, \ 
            int iProhibited_direction);
	int king_welmar(CHAR *ch, int cmd, char *arg);
	int training_master (CHAR *ch, int cmd, char *arg);	
	int tom (CHAR *ch, int cmd, char *arg);
	int tim (CHAR *ch, int cmd, char *arg);
	int James (CHAR *ch, int cmd, char *arg);
	int cleaning(CHAR *ch, int cmd, char *arg);
	int CastleGuard (CHAR *ch, int cmd, char *arg);
	int DicknDavid (CHAR *ch, int cmd, char *arg);
	int peter (CHAR *ch, int cmd, char *arg);
	int jerry (CHAR *ch, int cmd, char *arg);

        mob_index[real_mobile(8901)].func = king_welmar;
        mob_index[real_mobile(8903)].func = CastleGuard;
        mob_index[real_mobile(8904)].func = CastleGuard;
        mob_index[real_mobile(8905)].func = CastleGuard;
        mob_index[real_mobile(8906)].func = CastleGuard;
        mob_index[real_mobile(8907)].func = CastleGuard;
        mob_index[real_mobile(8908)].func = CastleGuard;
        mob_index[real_mobile(8909)].func = CastleGuard;
        mob_index[real_mobile(8910)].func = CastleGuard;
        mob_index[real_mobile(8911)].func = CastleGuard;
        mob_index[real_mobile(8912)].func = peter;
        mob_index[real_mobile(8913)].func = training_master;
        mob_index[real_mobile(8916)].func = James;
        mob_index[real_mobile(8917)].func = cleaning;
        mob_index[real_mobile(8920)].func = tim;
        mob_index[real_mobile(8921)].func = tom;
        mob_index[real_mobile(8924)].func = DicknDavid;
        mob_index[real_mobile(8925)].func = DicknDavid;
        mob_index[real_mobile(8926)].func = jerry;
        mob_index[real_mobile(8927)].func = CastleGuard;
        mob_index[real_mobile(8928)].func = CastleGuard;
        mob_index[real_mobile(8929)].func = CastleGuard;

}

/**********************************************************************\
|* Special procedures for Kings Castle by Pjotr (d90-pem@nada.kth.se) *|
|* Coded by Sapowox (d90-jkr@nada.kth.se)                             *|
\**********************************************************************/

#ifndef Z_KINGS_C
#define Z_KINGS_C 89
#endif

#define R_MOB(zone, mob) (real_mobile(((zone)*100)+(mob)))
#define R_OBJ(zone, obj) (real_object(((zone)*100)+(obj)))
#define R_ROOM(zone, num) (real_room(((zone)*100)+(num)))

#define CASTLE_ITEM(item) (Z_KINGS_C*100+(item))

/* Routine member_of_staff */
/* Used to see if a character is a member of the castle staff */
/* Used mainly by BANZAI'ng NPC's */
int member_of_staff (CHAR *ch)
{
 int ch_num; 
  
 if (!IS_NPC (ch) || !IS_MORTAL(ch)) return FALSE;
 ch_num = mob_index [ch->nr].virtual;
 return (ch_num == CASTLE_ITEM(1) ||
	    (ch_num > CASTLE_ITEM (2) && ch_num < CASTLE_ITEM(15)) ||
	    (ch_num > CASTLE_ITEM(15) && ch_num < CASTLE_ITEM(18)) ||
	    (ch_num > CASTLE_ITEM(18) && ch_num < CASTLE_ITEM(30)));
}

/* Function member_of_royal_guard */
/* Returns TRUE if the character is a guard on duty, otherwise FALSE */
/* Used by Peter the captain of the royal guard */
int member_of_royal_guard (CHAR *ch)
{
 int ch_num; 
  
 if (!ch || !IS_NPC (ch) || !IS_MORTAL(ch)) return FALSE;
 ch_num = mob_index[ch->nr].virtual;
 return (ch_num == CASTLE_ITEM(3) || ch_num == CASTLE_ITEM(6) ||
	    (ch_num > CASTLE_ITEM (7) && ch_num < CASTLE_ITEM(12)) ||
	    (ch_num > CASTLE_ITEM(23) && ch_num < CASTLE_ITEM(26)));
}

/* Function find_npc_by_name */
/* Returns a pointer to an npc by the given name */
/* Used by Tim and Tom */
CHAR *find_npc_by_name (CHAR *chAtChar, char *pszName, int iLen) 
{
 CHAR *ch;
  
 for (ch=world[chAtChar->in_room].people;ch;ch=ch->next_in_room)
  if (IS_NPC(ch)) 
   if (!strncmp (pszName, ch->player.short_descr, iLen))
	return (ch);
 return NULL;
}

/* Function find_guard */
/* Returns the pointer to a guard on duty. */
/* Used by Peter the Captain of the Royal Guard */
CHAR *find_guard (CHAR *chAtChar)
{
 CHAR *ch;
  
 for (ch=world[chAtChar->in_room].people;ch;ch=ch->next_in_room)
  if (!ch->specials.fighting && member_of_royal_guard (ch))
   return ch;
 return NULL;
}

/* Function get_victim */
/* Returns a pointer to a randomly chosen character in the same room, */
/* fighting someone in the castle staff... */
/* Used by BANZAII-ing characters and King Welmar... */
CHAR *get_victim (CHAR *chAtChar)
{
 CHAR *ch;
 int iNum_bad_guys = 0, iVictim;
  
 for (ch=world[chAtChar->in_room].people;ch;ch=ch->next_in_room)
  if (ch->specials.fighting && member_of_staff(ch->specials.fighting))
   iNum_bad_guys++;
 if (!iNum_bad_guys)
  return NULL;
 iVictim = number(0,iNum_bad_guys); /* How nice, we give them a chance */
 if (!iVictim) 
  return NULL;
 iNum_bad_guys = 0;
 for (ch=world[chAtChar->in_room].people;ch;ch=ch->next_in_room)
  if (ch->specials.fighting && 
      member_of_staff(ch->specials.fighting) &&
      ++iNum_bad_guys == iVictim)
      return ch;
 return NULL;
}


/* Function banzaii */
/* Makes a character banzaii random person in room */
/* Used by Guards, Tim, Tom, Dick, David, Peter, Master, King and Guards */
int banzaii (CHAR *ch)
{
 CHAR *vict;
  
 if (GET_POS(ch) == POSITION_FIGHTING) return FALSE;
 if (!(vict=get_victim(ch))) return FALSE;
 if(!IS_NPC(vict) && IS_MORTAL(vict))
 { 
  act ("$n roars, 'Protect the Kingdom of Great King Welmar! BANZAIIII!!!'",
   FALSE, ch, 0, 0, TO_ROOM) ;
  hit (ch, vict, TYPE_UNDEFINED);
  return TRUE;
 }
 return FALSE;
}


/* Function do_npc_rescue */
/* Makes ch_hero rescue ch_victim */
/* Used by Tim and Tom */
int do_npc_rescue (CHAR *hero, CHAR *victim)
{
 CHAR *badguy;
  
 for (badguy=world[hero->in_room].people; 
      badguy && (badguy->specials.fighting != victim); 
      badguy=badguy->next_in_room);
 if (badguy && (badguy->specials.fighting == victim))
 {
  if (badguy == hero) return FALSE;
  act ("You bravely rescue $N.",
   FALSE, hero, 0, victim, TO_CHAR) ;
  act("You are rescued by $N, your loyal friend!",
   FALSE, victim, 0, hero, TO_CHAR);
  act("$n heroically rescues $N.",
   FALSE, hero, 0, victim, TO_NOTVICT);
  if (badguy->specials.fighting)
   stop_fighting(badguy);
  if (hero->specials.fighting)
   stop_fighting(hero);
  set_fighting(hero, badguy);
  set_fighting(badguy, hero);
  return TRUE;
 }
 return FALSE;
}

/* Procedure to block a person trying to enter a room. */
/* Used by Tim/Tom at Kings bedroom and Dick/David at treasury */
int block_way(CHAR *ch, int cmd, char *arg, int iIn_room, 
              int iProhibited_direction)
{
 if (cmd != ++iProhibited_direction ||
    (!strncmp (ch->player.short_descr, "King Welmar", 11))) return FALSE;
 if ((ch->in_room == real_room(iIn_room)) && (cmd == iProhibited_direction))
 {
  if (!member_of_staff(ch))
  {
   act ("The guard roars at $n and pushes $m back.", 
    FALSE, ch, 0, 0, TO_ROOM);
   act("The guard roars, 'Entrance is Prohibited!' and pushes you back.",
    FALSE, ch,0 ,0, TO_CHAR);
   return TRUE;
  }
 }
 return FALSE;
}

/* Function king_welmar */
/* Control the actions and movements of the King. */
/* Used by King Welmar */
int king_welmar(CHAR *ch, int cmd, char *arg)
{
 CHAR *tch;
 static char *monolog [] = {
    "$n declaims 'Primus in regnis Geticis coronam'.",
    "$n declaims 'regiam gessi, subiique regis'.",
    "$n declaims 'munus et mores colui sereno'.",
    "$n declaims 'principe dignos'." };
 static char bedroom_path[] = "s33004o1c1S.";
 static char throne_path[] = "W3o3cG52211rg.";
 static char monolog_path[] = "ABCD.";
 static char *path;
 static int index;
 static bool move = FALSE;
 void do_move(CHAR *ch, char *argument, int cmd);
 void do_open(CHAR *ch, char *argument, int cmd);
 void do_lock(CHAR *ch, char *argument, int cmd);
 void do_unlock(CHAR *ch, char *argument, int cmd);
 void do_close(CHAR *ch, char *argument, int cmd);
  
 if (move == FALSE)
 {
  if (time_info.hours == 8 && ch->in_room == R_ROOM (Z_KINGS_C, 51))
  {
   move = TRUE;
   path = throne_path;
   index = 0;
  } 
  else if (time_info.hours == 12 && ch->in_room == R_ROOM (Z_KINGS_C, 17))
  {
   move = TRUE;
   path = monolog_path;
   index = 0;
  }
  else if (time_info.hours == 21 && ch->in_room == R_ROOM (Z_KINGS_C, 17))
  {
   move = TRUE;
   path = bedroom_path;
   index = 0;
  }
 }
 if(cmd) return FALSE;
 if(GET_POS(ch) < POSITION_SLEEPING) return FALSE;
 if(GET_POS(ch) == POSITION_SLEEPING && move == FALSE) return FALSE;
 if(GET_POS(ch) == POSITION_FIGHTING)
 {
  if (ch->points.mana < 10) return FALSE;
  if (!(tch = (CHAR *)get_random_victim(ch))) return FALSE;
  if(IS_NPC(tch) || !IS_MORTAL(tch)) return FALSE;
  switch (number (0,8))
  {
   case 0:
    act("You raise your hand in a dramatical gesture.",
     TRUE, ch, 0, 0, TO_CHAR);
    act("$n raises $s hand in a dramatical gesture.",
     TRUE, ch, 0, 0, TO_ROOM);
    cast_colour_spray (GET_LEVEL(ch), ch, "", SPELL_TYPE_SPELL, tch, 0);
    ch->points.mana -= 1;
    return TRUE;
   case 1:
    act("You concentrate and mumble to yourself.",
     TRUE, ch, 0, 0, TO_CHAR);
    act("$n concentrates, and mumbles to $mself.",
     TRUE, ch, 0, 0, TO_ROOM);
    cast_harm (GET_LEVEL(ch), ch, "", SPELL_TYPE_SPELL, tch, 0);
    ch->points.mana -= 1;
    return TRUE;
   case 2:
     act ("You look deep into the eyes of $N.",
      TRUE, ch, 0, tch, TO_CHAR);
     act ("$n looks deep into the eyes of $N.",
      TRUE, ch, 0, tch, TO_NOTVICT);
     act ("You see an ill-boding flame in the eye of $n.", 
	  TRUE, ch, 0, tch, TO_VICT) ;
     cast_fireball (GET_LEVEL(ch), ch, "", SPELL_TYPE_SPELL, tch, 0);
     ch->points.mana -= 1;
     return TRUE;
   case 3:
     act ("You utter the words, 'pzar', to heal yourself.", 
	  TRUE, ch, 0, 0, TO_CHAR) ;
     act ("$n utters the words, 'pzar'",
      TRUE, ch, 0, 0, TO_ROOM) ;
     cast_heal (GET_LEVEL(ch), ch, "", SPELL_TYPE_SPELL, ch, 0) ;
     ch->points.mana -= 1 ;
     return TRUE;
  }
  return FALSE;
 }
 else if (banzaii (ch)) return FALSE;
 if (move == FALSE) return FALSE;
 switch (path[index])
 {
  case '0' :
  case '1' :
  case '2' :
  case '3' :
  case '4' :
  case '5' :
    do_move(ch,"",path[index]-'0'+1);
    break;
  case 'A': case 'B': case 'C': case 'D':
    act(monolog [path[index]-'A'], FALSE, ch, 0, 0, TO_ROOM);
    break ;
  case 'W' :
    GET_POS(ch) = POSITION_STANDING;
    act("$n awakens and stands up.",FALSE,ch,0,0,TO_ROOM);
    break;
  case 'S' :
    GET_POS(ch) = POSITION_SLEEPING;
    act("$n lies down on $s beautiful bed and instantly falls asleep.",
	FALSE,ch,0,0,TO_ROOM);
    break;
  case 'r' :
    GET_POS(ch) = POSITION_SITTING;
    act("$n sits down on his great throne.", FALSE, ch, 0,0,TO_ROOM);
    break;
  case 's' :
    GET_POS(ch) = POSITION_STANDING;
    act("$n stands up.",FALSE,ch,0,0,TO_ROOM);
    break;
  case 'G' :
    act("$n says 'Good morning, trusted friends.'",FALSE,ch,0,0,TO_ROOM);
    break;
  case 'g' :
    act("$n says 'Good morning, dear subjects.'",FALSE,ch,0,0,TO_ROOM);
    break;
  case 'o' :
    do_unlock(ch, "door", 0);
    do_open(ch, "door", 0);
    break;
  case 'c' :
    do_close(ch, "door", 0);
    do_lock(ch, "door", 0);
    break;
  case '.' :
    move = FALSE;
    break;
  }
  index++;
  return FALSE;
}

/* Function training_master */
/* Acts actions to the training room, if his students are present */
/* Also allows warrior-class to practice */
/* Used by the Training Master */
int training_master (CHAR *ch, int cmd, char *arg)
{
 CHAR *pupil1, *pupil2, *tch;
  
 if(!AWAKE(ch) || (GET_POS(ch) == POSITION_FIGHTING)) return FALSE;
 if((cmd == 164) || (cmd == 170))
 {
  if(GET_CLASS(ch) == CLASS_WARRIOR)
   guild (ch, cmd, arg);
  else
   act("The Training Master does not allow your class to practice here.",
    TRUE, ch, 0, 0, TO_CHAR);
  return TRUE;
 }
 if(cmd) return FALSE ;
 if(!banzaii(ch) && !number (0,2))
 {
  if((pupil1 = find_npc_by_name (ch, "Brian", 5)) &&
	(pupil2 = find_npc_by_name (ch, "Mick", 4)) &&
	(!pupil1->specials.fighting) && (!pupil2->specials.fighting))
  {
   if (number(0,1) == 1)
   {
	tch = pupil1;
	pupil1 = pupil2;
	pupil2 = tch;
   }
   switch (number (0,7))
   {
    case 0:
	 act("$n hits $N on $s head with a powerful blow.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("You hit $N on $s head with a powerful blow.",
	  FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act("$n hits you on your head with a powerful blow.",
	  FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    case 1:
	 act("$n hits $N in $s chest with a thrust.",
	     FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("You manage to thrust $N in the chest.",
	     FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act("$n manages to thrust you in your chest.",
	     FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    case 2:
	 act("You command your pupils to bow.",
	  FALSE, ch, 0, 0, TO_CHAR);
	 act("$n commands his pupils to bow.",
	  FALSE, ch, 0, 0, TO_ROOM);
	 act("$n bows before $N.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("$N bows before $n.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("You bow before $N, who returns your gesture.",
	  FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act ("You bow before $n, who returns your gesture.",
	  FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    case 3:
	 act("$N yells at $n, as he fumbles and drops his sword.",
	  FALSE, pupil1, 0, ch, TO_NOTVICT);
	 act("$n quickly picks up his weapon.",
	  FALSE, pupil1, 0, 0, TO_ROOM);
	 act("$N yells at you, as you fumble, losing your weapon.",
	  FALSE, pupil1, 0, ch, TO_CHAR);
	 act("You quickly pick up your weapon again.",
	  FALSE, pupil1, 0, 0, TO_CHAR);
	 act("You yell at $n, as he fumbles, losing his weapon.",
	  FALSE, pupil1, 0, ch, TO_VICT);
	 break;
    case 4:
	 act("$N tricks $n, and slashes him across the back.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("$N tricks you, and slashes you across your back.",
	  FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act("You trick $n, and quickly slash him across his back.",
	  FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    case 5:
	 act("$n lunges a blow at $N but $N parries skillfully.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("You lunge a blow at $N but $E parries skillfully.",
	  FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act("$n lunges a blow at you, but you skillfully parry it.",
	  FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    case 6:
	 act("$n clumsily tries to kick $N, but misses.",
	  FALSE, pupil1, 0, pupil2, TO_NOTVICT);
	 act("You clumsily miss $N with your poor excuse for a kick.",
	  FALSE, pupil1, 0, pupil2, TO_CHAR);
	 act("$n fails an unusually clumsy attempt at kicking you.",
	  FALSE, pupil1, 0, pupil2, TO_VICT);
	 break;
    default:
	 act("You show your pupils an advanced technique.",
	  FALSE, ch, 0, 0, TO_CHAR);
	 act("$n shows his pupils an advanced technique.",
	  FALSE, ch, 0, 0, TO_ROOM);
	 break;
   }
   return TRUE;
  }
 }
 return FALSE ;
}


int tom (CHAR *ch, int cmd, char *arg)
{
 CHAR *king, *tim;
  
 if (!(AWAKE(ch))) return FALSE;
 if(cmd) return FALSE;
 if (king = find_npc_by_name(ch, "King Welmar", 11))
 {
  if(!(ch->master))
   do_follow (ch, "King Welmar", 0); 
  if(king->specials.fighting) do_npc_rescue(ch, king);
 }
 if(tim = find_npc_by_name(ch, "Tim", 3))
  if(tim->specials.fighting && (2*tim->points.hit < ch->points.hit))
	do_npc_rescue (ch, tim);
  if(GET_POS(ch) != POSITION_FIGHTING) banzaii(ch);
  return block_way(ch, cmd, arg, CASTLE_ITEM(49), 1);
}

int tim (CHAR *ch, int cmd, char *arg)
{
 CHAR *king, *tom;
  
 if (!AWAKE(ch)) return FALSE ;
 if(cmd) return FALSE;
 if (king = find_npc_by_name(ch, "King Welmar", 11))
 {
  if (!(ch->master))
   do_follow (ch, "King Welmar", 0); 
  if (king->specials.fighting)
   do_npc_rescue (ch, king);
 }
 if (tom = find_npc_by_name(ch, "Tom", 3))
  if (tom->specials.fighting && (2*tom->points.hit < ch->points.hit))
   do_npc_rescue (ch, tom);
 if (GET_POS(ch) != POSITION_FIGHTING) banzaii (ch);
 return block_way(ch, cmd, arg, CASTLE_ITEM(49), 1);
}


/* Routine for James the Butler */
/* Complains if he finds any trash... */
int James (CHAR *ch, int cmd, char *arg)
{
 OBJ *i;
  
 if(cmd || GET_POS(ch) == POSITION_FIGHTING) return (FALSE);
 for(i=world[ch->in_room].contents;i;i=i->next_content)
  if(IS_SET(i->obj_flags.wear_flags, ITEM_TAKE) &&
    ((i->obj_flags.type_flag == ITEM_DRINKCON) ||
    (i->obj_flags.cost <= 10)))
  {
   act("$n says: 'My oh my! I ought to fire that lazy cleaning woman!'", 
	FALSE, ch, 0, 0, TO_ROOM);
   act ("$n picks up a piece of trash.",
    FALSE, ch, 0, 0, TO_ROOM);
   obj_from_room(i);
   obj_to_char (i, ch);
   return TRUE; 
  }
 return FALSE;
} 

/* Routine for the Cleaning Woman */
/* Picks up any trash she finds... */
int cleaning(CHAR *ch, int cmd, char *arg)
{
 OBJ *i;
  
 if (cmd || !AWAKE(ch)) return(FALSE);
 for (i=world[ch->in_room].contents;i;i=i->next_content)
  if(IS_SET(i->obj_flags.wear_flags, ITEM_TAKE) &&
    ((i->obj_flags.type_flag == ITEM_DRINKCON) ||
    (i->obj_flags.cost <= 10)))
  {
   act("$n picks up some trash.",
    FALSE, ch, 0, 0, TO_ROOM);
   obj_from_room (i);
   obj_to_char (i, ch);
   return TRUE ;
  }
 return FALSE ;
}

/* Routine CastleGuard */
/* Standard routine for ordinary castle guards */
int CastleGuard (CHAR *ch, int cmd, char *arg)
{
 if (cmd || GET_POS(ch) == POSITION_FIGHTING) return FALSE;
 return (banzaii (ch));
}

/* Routine DicknDave */
/* Routine for the guards Dick and David */
int DicknDavid (CHAR *ch, int cmd, char *arg)
{
 if (!cmd && GET_POS(ch) != POSITION_FIGHTING) banzaii (ch); 
 return (block_way (ch, cmd, arg, CASTLE_ITEM(36), 1));
}

/* Routine peter */
/* Routine for Captain of the Guards. */
int peter (CHAR *ch, int cmd, char *arg)
{
 CHAR *ch_guard;
  
 if (cmd || !AWAKE(ch) || GET_POS(ch) == POSITION_FIGHTING) return (FALSE);
 if(banzaii(ch)) return FALSE;
 if(!(number(0,3)) && (ch_guard = find_guard(ch)))
  switch (number(0,5))
  {
   case 0:
    act("$N comes sharply into attention as $n inspects $M.",
	 FALSE, ch, 0, ch_guard, TO_NOTVICT);
    act("$N comes sharply into attention as you inspect $M.",
	 FALSE, ch, 0, ch_guard, TO_CHAR);
    act("You go sharply into attention as $n inspects you.",
	 FALSE, ch, 0, ch_guard, TO_VICT);
    break;
   case 1:
    act("$N looks very small, as $n roars at $M.",
	 FALSE, ch, 0, ch_guard, TO_NOTVICT);
    act("$N looks very small as you roar at $M.",
	 FALSE, ch, 0, ch_guard, TO_CHAR);
    act("You feel very small as $N roars at you.",
	 FALSE, ch, 0, ch_guard, TO_VICT);
    break;
   case 2:
    act("$n gives $N some Royal directions.",
	 FALSE, ch, 0, ch_guard, TO_NOTVICT);
    act("You give $N some Royal directions.",
	 FALSE, ch, 0, ch_guard, TO_CHAR);
    act("$n gives you some Royal directions.",
	 FALSE, ch, 0, ch_guard, TO_VICT);
    break;
   case 3:
    act("$n looks at you.",
     FALSE, ch, 0, ch_guard, TO_VICT);
    act("$n looks at $N.",
     FALSE, ch, 0, ch_guard, TO_NOTVICT);
    act("$n growls: 'Those boots need polishing!'",
	 FALSE, ch, 0, ch_guard, TO_ROOM);
    act("You growl at $N.",
     FALSE, ch, 0, ch_guard, TO_CHAR);
    break;
   case 4:
    act("$n looks at you.",
     FALSE, ch, 0, ch_guard, TO_VICT);
    act("$n looks at $N.",
     FALSE, ch, 0, ch_guard, TO_NOTVICT) ;
    act("$n growls: 'Straighten that collar!'",
	 FALSE, ch, 0, ch_guard, TO_ROOM);
    act ("You growl at $N.",
     FALSE, ch, 0, ch_guard, TO_CHAR);
    break;
   default:
    act("$n looks at you.",
     FALSE, ch, 0, ch_guard, TO_VICT);
    act("$n looks at $N.",
     FALSE, ch, 0, ch_guard, TO_NOTVICT);
    act ("$n growls: 'That chain mail looks rusty!  CLEAN IT !!!'",
	 FALSE, ch, 0, ch_guard, TO_ROOM);
    act ("You growl at $N.",
     FALSE, ch, 0, ch_guard, TO_CHAR);
    break;
  }
 return FALSE ;
}

/* Procedure for Jerry and Michael in x08 of King's Castle.      */
/* Code by Sapowox modified by Pjotr.(Original code from Master) */

int jerry (CHAR *ch, int cmd, char *arg)
{
 CHAR *gambler1, *gambler2, *tch ;

 if (!AWAKE(ch) || (GET_POS(ch)==POSITION_FIGHTING)) return FALSE;
 if (cmd) return FALSE;
 if (!banzaii (ch) && !number (0,2))
 {
  if ((gambler1=ch) &&
	 (gambler2=find_npc_by_name(ch,"Michael",7)) &&
	 (!gambler1->specials.fighting) && (!gambler2->specials.fighting))
  {
   if (number(0,1))
   {
	tch = gambler1;
	gambler1 = gambler2;
	gambler2 = tch;
   }
   switch (number (0,5))
   {
    case 0:
	 act("$n rolls the dice and cheers loudly at the result.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You roll the dice and cheer. GREAT!",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n cheers loudly as $e rolls the dice.",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
    case 1:
	 act("$n curses the Goddess of Luck roundly as he sees $N's roll.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You curse the Goddess of Luck as $N rolls.",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n swears angrily. You are in luck!",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
    case 2:
	 act("$n sighs loudly and gives $N some gold.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You sigh loudly at the pain of having to give $N some gold.",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n sighs loudly as $e gives you your rightful win.",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
    case 3:
	 act("$n smiles remorsefully as $N's roll tops his.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You smile sadly as you see that $N beats you. Again.",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n smiles remorsefully as your roll tops his.",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
    case 4:
	 act("$n excitedly follows the dice with his eyes.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You excitedly follow the dice with your eyes.",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n excitedly follows the dice with his eyes.",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
    default:
	 act("$n says 'Well, my luck has to change soon', as he shakes the dice.",
	     FALSE, gambler1, 0, gambler2, TO_NOTVICT);
	 act("You say 'Well, my luck has to change soon' and shake the dice.",
	     FALSE, gambler1, 0, gambler2, TO_CHAR);
	 act("$n says 'Well, my luck has to change soon', as he shakes the dice.",
	     FALSE, gambler1, 0, gambler2, TO_VICT);
	 break;
   }
  }
  return TRUE;
 }
 return FALSE;
}
